#!/usr/bin/python2.2 -S

import sys
import sitecustomize
#  Contains Ensim package paths!
import site

import string
import cache
import configuration
import quota_information
import mailer
import admin_information as admins
import getopt

def check_user_quotas(site_id):

    config = configuration.get_configuration()
    user_thresholds = config.user_thresholds
    opts = configuration.options

    for quota in quota_information.get_user_quotas(site_id):
        for limit in user_thresholds:
            if quota.percent_used > limit.threshold:
                admins.save_site_admin(quota)
                print "User %s/%s over %s threshold: %f" % (
                    quota.username, quota.admin_id, limit.name, limit.threshold)
                cache.save_user_quota_info(quota, limit)
                if opts.user_email == 1:
                    mailer.notify_user(quota, limit)
                break

def check_site_quotas():

    config = configuration.get_configuration()
    site_thresholds = config.site_thresholds
    opts = configuration.options

    for site_id in quota_information.get_all_site_ids():

        quota = quota_information.get_site_quota(site_id)
        if quota != None:
            for limit in site_thresholds:
                if quota.percent_used > limit.threshold:
                    print "Domain %s/%s over %s threshold: %f" % (
                        quota.domain, quota.admin_id, limit.name, 
                        limit.threshold)
                    admins.save_reseller(quota)
                    admins.save_site_admin_by_id(quota.id)
                    cache.save_site_quota_info(quota, limit)
                    if opts.site_admin_email == 1:
                        mailer.notify_site_admin(quota, limit)
                    break

        check_user_quotas(site_id)

if __name__ == '__main__':
    

    config = configuration.get_configuration()

    #  Override config OutputOptions with command line 
    #  arguments if present

    long_opts = [
        'no-user-email',
        'no-site-email',
        'no-user-summary-email',
        'no-site-summary-email'
    ]

    help = """%s: [--no-user-email] [--no-site-email] \\
  %*s[--no-user-summary-email] [--no-site-summary-email]""" \
                  % (sys.argv[0], len(sys.argv[0]), ' ')

    wanted = {}
    wanted, left = getopt.getopt(sys.argv[1:], None, long_opts)

    if len(left) > 0:
        print "Invalid options: %s" % string.join(left[1:], ', ')
        print help
        sys.exit(1)

    for got in wanted:
        opt = got[0]
        if opt == '--no-user-email':
            config.options.user_email = 0
        if opt == '--no-site-email':
            config.options.site_admin_email = 0
        if opt == '--no-user-summary-email':
            config.options.user_summary_email = 0
        if opt == '--no-site-summary-email':
            config.options.site_summary_email = 0

    check_site_quotas()

    if config.options.user_summary_email == 1:
        mailer.notify_site_admins(admins.get_over_quota_site_admins())

    if config.options.site_summary_email == 1:
        mailer.notify_resellers(admins.get_over_quota_resellers())

